import pygame
from pygame.sprite import Sprite

class Ship(Sprite):
    def __init__(self, ai_settings, screen):
        """
        初始化飞船并设置其初始位置
        """
        super().__init__()
        self.screen = screen
        
        # 移动标志
        self.moving_right = False
        self.moving_left = False

        # 加载飞船图像并且获取外接矩形
        self.image = pygame.image.load('image/ship.bmp')
        self.rect = self.image.get_rect()
        self.screen_rect = self.screen.get_rect()

        # 将每艘飞船放在屏幕底部中央
        self.rect.centerx = self.screen_rect.centerx
        self.rect.bottom = self.screen_rect.bottom

        # 创建一个setting的对象
        self.ai_settings = ai_settings

        # 在飞船的属性center中存储小数值
        self.center = float(self.rect.centerx)

    def blitme(self):
        """在指定的位置绘制飞船"""
        self.screen.blit(self.image, self.rect)

    def update(self):
        """
        根据移动的标志调整飞船的位置
        :return:
        """
        if self.moving_right and self.rect.right < self.screen_rect.right:
            self.center += self.ai_settings.ship_speed_factor
        if self.moving_left and self.rect.left > 0:
            self.center -= self.ai_settings.ship_speed_factor

        # 根据self.center更新rect对象
        self.rect.centerx = self.center

    def center_ship(self):
        """
        让飞船居中在屏幕上
        :return:
        """
        self.center = self.screen_rect.centerx